diff --git a/bin/hive b/bin/hive
index 60ea4682..df50a93e 100755
--- a/bin/hive
+++ b/bin/hive
@@ -5,12 +5,18 @@ $LOAD_PATH.unshift(File.expand_path("../lib", __dir__))
 require "hive"
 require "hive/cli"
 require "json"
+require "hive/invoked_binary"
 
 if ARGV == [ "--version" ] || ARGV == [ "-v" ]
   puts Hive::VERSION
   exit 0
 end
 
+if ARGV == [ "--install-fingerprint" ]
+  puts JSON.generate(Hive::InvokedBinary.loaded_identity)
+  exit 0
+end
+
 JSON_TRUE_OPTIONS = %w[--json --json=true --json=TRUE --json=t --json=T].freeze
 JSON_FALSE_OPTIONS = %w[--no-json --skip-json --json=false --json=FALSE --json=f --json=F].freeze
 JSON_BOOLEAN_OPTIONS = (JSON_TRUE_OPTIONS + JSON_FALSE_OPTIONS).freeze
diff --git a/lib/hive.rb b/lib/hive.rb
index b22bfe0e..fa9268d5 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -62,7 +62,7 @@ module Hive
       # `dispatch_requests/` directory. See
       # `Hive::Daemon::DispatchRequestQueue` and
       # `Hive::Bot::DispatchRequestWriter`.
-      "hive-dispatch-request" => 2,
+      "hive-dispatch-request" => 3,
       # Reverse-direction notice the daemon writes for the bot to relay a
       # non-zero, bot-originated dispatch back to the originating Telegram
       # chat. See `Hive::Daemon::DispatchResultQueue` (ADV-1).
diff --git a/lib/hive/brainstorm_parser.rb b/lib/hive/brainstorm_parser.rb
index 88492e11..02cc8f9b 100644
--- a/lib/hive/brainstorm_parser.rb
+++ b/lib/hive/brainstorm_parser.rb
@@ -106,6 +106,10 @@ module Hive
       parsed.select { |question| question.answer.nil? }
     end
 
+    def answered_questions(parsed)
+      parsed.select(&:answered?)
+    end
+
     def question_for(parsed, question_n)
       parsed.find { |question| question.n == question_n }
     end
diff --git a/lib/hive/claude_launcher.rb b/lib/hive/claude_launcher.rb
index 15b092ae..0df66845 100644
--- a/lib/hive/claude_launcher.rb
+++ b/lib/hive/claude_launcher.rb
@@ -488,7 +488,7 @@ module Hive
                         mcp_config_path: nil, strict_mcp_config: false)
       command = [
         "bash",
-        File.expand_path("scripts/interactive_claude_wrapper.sh", __dir__),
+        interactive_wrapper_path,
         "--cwd", cwd
       ]
       Array(add_dirs).each { |dir| command.concat([ "--add-dir", dir ]) }
@@ -506,6 +506,30 @@ module Hive
       command
     end
 
+    def interactive_wrapper_path
+      File.expand_path("scripts/interactive_claude_wrapper.sh", __dir__)
+    end
+
+    # Deterministic canary through the production readiness parser. A parser
+    # edit that accepts the trust wall or rejects the known idle pane disables
+    # Claude auto-recovery before it can clear any marker.
+    def readiness_self_check
+      accepted = <<~PANE
+        Claude Code
+
+        ❯
+        ⏵⏵ bypass permissions · for agents
+      PANE
+      rejected = <<~PANE
+        Claude Code
+
+        Quick safety check
+        Yes, I trust this folder
+        ❯
+      PANE
+      claude_ready_prompt?(accepted) && !claude_ready_prompt?(rejected)
+    end
+
     def mcp_cli_flags(path, strict)
       return [] if path.to_s.strip.empty?
 
diff --git a/lib/hive/commands/doctor.rb b/lib/hive/commands/doctor.rb
index 99afbc08..3b6184b8 100644
--- a/lib/hive/commands/doctor.rb
+++ b/lib/hive/commands/doctor.rb
@@ -45,11 +45,13 @@ module Hive
       # JSON encoder. Returns `nil` before `#call` has populated it.
       attr_reader :rows
 
-      def initialize(config:, project_root:, json: false, output: $stdout)
+      def initialize(config:, project_root:, json: false, output: $stdout,
+                     agent_health_checker: nil)
         @config = config
         @project_root = project_root
         @json = json
         @output = output
+        @agent_health_checker = agent_health_checker || method(:probe_agent_health)
         @rows = nil
       end
 
@@ -71,6 +73,20 @@ module Hive
         EXIT_CONFIG_ERROR
       end
 
+      # Lightweight in-process subset used by daemon recovery. It checks only
+      # configured required stage/reviewer agents and skills; advisory runtime
+      # rows (qmd migration hints, exported-key warnings) retain CLI semantics
+      # but do not make dependency recovery unhealthy.
+      def required_checks
+        @rows = check_required_agents + check_stages + check_reviewers
+        {
+          healthy: @rows.none? { |row| failing_status?(row[:status]) },
+          rows: @rows
+        }
+      rescue Hive::ConfigError, KeyError, ArgumentError => e
+        { healthy: false, rows: [], error: "#{e.class}: #{e.message}" }
+      end
+
       private
 
       def failing_status?(status)
@@ -81,6 +97,58 @@ module Hive
         STAGES.map { |stage| check_stage(stage) }
       end
 
+      def check_required_agents
+        required_agent_names.map do |agent_name|
+          profile = Hive::AgentProfiles.lookup(agent_name.to_sym, cfg: @config)
+          status, message = @agent_health_checker.call(profile)
+          {
+            kind: "agent",
+            stage: "agent",
+            label: "agent/#{agent_name}",
+            agent: agent_name,
+            configured_skill: profile.bin,
+            skill: "#{profile.bin} #{profile.version_flag}",
+            status: status.to_s,
+            message: message.to_s
+          }
+        end
+      end
+
+      def required_agent_names
+        paths = Hive::Config::ROLE_AGENT_PATHS.reject do |path|
+          (path == %w[review ci agent] && @config.dig("review", "ci", "command").to_s.empty?) ||
+            (path == %w[review triage agent] && @config.dig("review", "triage", "enabled") == false) ||
+            (path == %w[review browser_test agent] &&
+              @config.dig("review", "browser_test", "enabled") != true)
+        end
+        names = paths.filter_map do |path|
+          (@config.dig(*path) || Hive::Config::DEFAULTS.dig(*path)).to_s.then do |name|
+            name unless name.empty?
+          end
+        end
+        Array(@config.dig("review", "reviewers")).each do |spec|
+          next unless %w[agent codex_review].include?((spec["kind"] || "agent").to_s)
+
+          name = spec["agent"].to_s
+          names << name unless name.empty?
+        end
+        names.uniq
+      end
+
+      def probe_agent_health(profile)
+        version = profile.check_version!
+        profile.preflight!
+        [
+          "present",
+          "#{profile.name} #{version} is runnable#{profile.min_version ? " (minimum #{profile.min_version})" : ""}"
+        ]
+      rescue Hive::AgentError => e
+        status = e.message.include?("below minimum") ? "version_too_old" : "missing"
+        [ status, e.message ]
+      rescue StandardError => e
+        [ "missing", "#{profile.name} preflight failed: #{e.class}: #{e.message}" ]
+      end
+
       def check_tmux
         return [] unless Hive::Config.claude_mode(@config) == :tmux
 
diff --git a/lib/hive/commands/markers.rb b/lib/hive/commands/markers.rb
index f5df7df1..764b2721 100644
--- a/lib/hive/commands/markers.rb
+++ b/lib/hive/commands/markers.rb
@@ -6,6 +6,7 @@ require "hive/markers"
 require "hive/lock"
 require "hive/git_ops"
 require "hive/stages"
+require "hive/events"
 
 module Hive
   module Commands
@@ -96,7 +97,6 @@ module Hive
         folder = resolve_target
         task = Hive::Task.new(folder)
         validate_project_path_match!(task)
-
         # Read+validate+rewrite must run under the same `.markers-lock`
         # that `Hive::Markers.set` uses. Otherwise a concurrent
         # `hive run` writes a NEW marker between our validation and our
@@ -105,6 +105,7 @@ module Hive
         # `with_commit_lock` to serialise hive/state branch writes
         # against any concurrent committer (auto-heal, run loop).
         Hive::Markers.with_markers_lock(task.state_file) do
+          original_body = File.binread(task.state_file)
           marker = Hive::Markers.current(task.state_file)
           actual = marker.name.to_s.upcase
           unless actual == normalized
@@ -115,6 +116,12 @@ module Hive
 
           match_attr_or_raise!(task, marker)
           Hive::Markers.remove_marker(task.state_file, marker.raw)
+          begin
+            emit_manual_clear_event(task, marker)
+          rescue StandardError
+            Hive::Markers.write_atomic(task.state_file, original_body)
+            raise
+          end
         end
 
         Hive::Lock.with_commit_lock(task.hive_state_path) do
@@ -124,6 +131,28 @@ module Hive
         emit_success(task, normalized)
       end
 
+      def emit_manual_clear_event(task, marker)
+        Hive::Events.emit_required(
+          task_folder: task.folder,
+          slug: task.slug,
+          stage: "#{task.stage_index}-#{task.stage_name}",
+          event_type: :marker_cleared,
+          message: "manually cleared #{marker.name.to_s.upcase}",
+          details: {
+            "task_id" => task.id,
+            "task_slug" => task.slug,
+            "stage" => "#{task.stage_index}-#{task.stage_name}",
+            "marker_id" => marker.attrs["marker_id"],
+            "marker_reason" => marker.attrs["reason"],
+            "marker_name" => marker.name.to_s,
+            "actor" => "manual",
+            "action" => "marker_cleared",
+            "rationale" => "operator requested marker clear",
+            "timestamp" => Time.now.utc.iso8601(6)
+          }
+        )
+      end
+
       # Cross-process race guard. The TUI observes an ERROR marker at
       # time T and dispatches `hive markers clear` at T+1s. If a
       # concurrent `hive run` writes a fresh ERROR marker in that
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index c686876b..2fadf982 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -313,6 +313,9 @@ module Hive
       "daemon" => {
         "enabled" => false,
         "autostart" => false,
+        "auto_retry" => {
+          "enabled" => true
+        },
         "poll_interval_sec" => 30,
         "fast_poll_sec" => 1,
         "edit_debounce_sec" => 30,
@@ -2225,6 +2228,19 @@ module Hive
               "(true / false); got #{autostart.inspect} (#{autostart.class})"
       end
 
+      auto_retry = daemon["auto_retry"]
+      unless auto_retry.nil? || auto_retry.is_a?(Hash)
+        raise ConfigError,
+              "daemon.auto_retry in #{describe_source(source_path)} must be a Hash; " \
+              "got #{auto_retry.class}"
+      end
+      auto_retry_enabled = auto_retry && auto_retry["enabled"]
+      unless auto_retry_enabled.nil? || auto_retry_enabled == true || auto_retry_enabled == false
+        raise ConfigError,
+              "daemon.auto_retry.enabled in #{describe_source(source_path)} must be a boolean " \
+              "(true / false); got #{auto_retry_enabled.inspect} (#{auto_retry_enabled.class})"
+      end
+
       DAEMON_NUMERIC_BOUNDS.each do |key, min|
         value = daemon[key]
         next if value.nil?
diff --git a/lib/hive/daemon/auto_retry.rb b/lib/hive/daemon/auto_retry.rb
new file mode 100644
index 00000000..8c61f352
--- /dev/null
+++ b/lib/hive/daemon/auto_retry.rb
@@ -0,0 +1,388 @@
+require "time"
+require "hive/daemon/auto_retry_history"
+require "hive/daemon/dispatch_request_queue"
+require "hive/events"
+require "hive/markers"
+
+module Hive
+  module Daemon
+    # Coordinates fail-closed recovery for the fixed dependency-failure
+    # allowlist. The policy proves provenance/work safety, the probe proves
+    # current health, and the history owns the durable attempt budget.
+    class AutoRetry
+      PROBE_FALLBACK_SEC = 600
+      NEGATIVE_AUDIT_THROTTLE_SEC = 600
+
+      Result = Struct.new(
+        :action, :rationale, :request_id, :attempt, :fingerprint,
+        keyword_init: true
+      )
+
+      def initialize(policy:, probe_factory:, state_home:, history: AutoRetryHistory.new,
+                     request_queue: DispatchRequestQueue, markers: Hive::Markers,
+                     events: Hive::Events, audit: nil, dry_run: false)
+        @policy = policy
+        @probe_factory = probe_factory
+        @state_home = state_home
+        @history = history
+        @request_queue = request_queue
+        @markers = markers
+        @events = events
+        @audit = audit || ->(**_attrs) { }
+        @dry_run = dry_run
+        @probe_cache = {}
+        @negative_audits = {}
+      end
+
+      def tick(rows, now: Time.now)
+        @tick_probe_cache = {}
+        evict_negative_audits(now)
+        seen = {}
+        Array(rows).filter_map do |row|
+          key = marker_key(row)
+          next if key && seen[key]
+
+          seen[key] = true if key
+          process(row, now: now)
+        rescue StandardError => e
+          audit(row, action: "coordinator_error",
+                     rationale: "#{e.class}: #{e.message}", transition: true, now: now)
+          Result.new(action: "coordinator_error", rationale: "#{e.class}: #{e.message}")
+        end
+      end
+
+      private
+
+      def process(row, now:)
+        policy = @policy.evaluate(row)
+        unless policy.eligible
+          unless policy.action == "not_current_terminal_error"
+            audit(row, action: policy.action, rationale: policy.rationale, now: now)
+          end
+          return Result.new(action: policy.action, rationale: policy.rationale)
+        end
+
+        reason = policy.reason
+        pending = @dry_run ? nil : pending_retry_request(row, policy.marker_id)
+        budget = @history.budget(task_folder: row.folder, reason: reason, now: now)
+        unless budget.eligible || pending
+          audit(row, action: budget.action, rationale: budget.rationale, now: now)
+          return Result.new(action: budget.action, rationale: budget.rationale)
+        end
+
+        aggregate = probe(row, policy, reason, now)
+        unless aggregate.healthy
+          rationale = unhealthy_rationale(aggregate)
+          audit(row, action: "dependency_unhealthy", rationale: rationale,
+                     aggregate: aggregate, now: now)
+          return Result.new(
+            action: "dependency_unhealthy", rationale: rationale,
+            fingerprint: aggregate.fingerprint
+          )
+        end
+
+        if pending
+          attempt = @history.reserved_attempt(
+            task_folder: row.folder, reason: reason, marker_id: policy.marker_id
+          )
+          unless attempt
+            rationale = "guarded request has no matching durable reservation"
+            audit(row, action: "history_invalid", rationale: rationale,
+                       aggregate: aggregate, request_id: pending.request_id,
+                       transition: true, now: now)
+            return Result.new(action: "history_invalid", rationale: rationale)
+          end
+          return complete_retry(
+            row, policy, aggregate, attempt, pending.request_id, now,
+            resumed: true
+          )
+        end
+
+        decision = @history.assess(
+          task_folder: row.folder, reason: reason,
+          fingerprint: aggregate.fingerprint, now: now
+        )
+        unless decision.eligible
+          audit(row, action: decision.action, rationale: decision.rationale,
+                     aggregate: aggregate, now: now)
+          return Result.new(
+            action: decision.action, rationale: decision.rationale,
+            fingerprint: aggregate.fingerprint
+          )
+        end
+
+        return dry_run_result(row, decision.attempt, aggregate, now) if @dry_run
+
+        retry_task(row, policy, decision, aggregate, now)
+      end
+
+      def retry_task(row, policy, decision, aggregate, now)
+        probes = probe_summaries(aggregate)
+        reserved = @history.reserve!(
+          task_folder: row.folder,
+          task_id: row.id,
+          slug: row.slug,
+          stage: row.stage,
+          marker_id: policy.marker_id,
+          reason: policy.reason,
+          fingerprint: aggregate.fingerprint,
+          attempt: decision.attempt,
+          probes: probes,
+          now: now
+        )
+        unless reserved
+          rationale = "durable retry reservation could not be appended"
+          audit(row, action: "reservation_failed", rationale: rationale,
+                     aggregate: aggregate, attempt: decision.attempt,
+                     transition: true, now: now)
+          return Result.new(action: "reservation_failed", rationale: rationale)
+        end
+        audit(row, action: "retry_reserved", rationale: "durable retry attempt reserved",
+                   aggregate: aggregate, attempt: decision.attempt,
+                   transition: true, task_event: false, now: now)
+
+        request_id = enqueue(row, policy.marker_id, now)
+        unless request_id
+          rationale = "dispatch request could not be persisted"
+          audit(row, action: "queue_failed", rationale: rationale,
+                     aggregate: aggregate, attempt: decision.attempt,
+                     transition: true, now: now)
+          return Result.new(
+            action: "queue_failed", rationale: rationale,
+            attempt: decision.attempt, fingerprint: aggregate.fingerprint
+          )
+        end
+
+        complete_retry(
+          row, policy, aggregate, decision.attempt, request_id, now,
+          resumed: false
+        )
+      end
+
+      def complete_retry(row, policy, aggregate, attempt, request_id, now, resumed:)
+        probes = probe_summaries(aggregate)
+        cleared = @markers.clear_current(
+          row.state_file,
+          expected_name: :error,
+          match_attrs: { "marker_id" => policy.marker_id }
+        ) do
+          emit_automatic_clear(row, policy, aggregate, attempt, request_id, probes, now)
+        end
+        unless cleared
+          withdrawn = @request_queue.remove_if_unclaimed(
+            request_id, state_home: @state_home
+          )
+          rationale = withdrawn ? "marker changed; unclaimed request withdrawn" :
+            "marker changed after request was claimed"
+          audit(row, action: "marker_race", rationale: rationale,
+                     aggregate: aggregate, attempt: attempt,
+                     request_id: request_id, transition: true, now: now)
+          return Result.new(
+            action: "marker_race", rationale: rationale,
+            request_id: request_id, attempt: attempt,
+            fingerprint: aggregate.fingerprint
+          )
+        end
+
+        audit(row, action: "retry_queued", rationale: "marker cleared and same-stage run queued",
+                   aggregate: aggregate, attempt: attempt,
+                   request_id: request_id, transition: true, task_event: false, now: now)
+        Result.new(
+          action: "retry_queued",
+          rationale: resumed ? "resumed reserved request; marker cleared and same-stage run queued" :
+            "marker cleared and same-stage run queued",
+          request_id: request_id,
+          attempt: attempt,
+          fingerprint: aggregate.fingerprint
+        )
+      end
+
+      def enqueue(row, marker_id, now)
+        @request_queue.write_request!(
+          project: row.project,
+          slug: row.slug,
+          argv: [
+            "hive", "run", row.slug, "--project", row.project,
+            "--stage", row.stage
+          ],
+          # The queue's daemon-originated producer identity is `healer`.
+          # The dedicated subsystem remains distinguishable by trigger and
+          # task/daemon audit actor without widening the wire enum.
+          requestor: "healer",
+          trigger: "recoverable_dependency_failure",
+          expected_cleared_marker_id: marker_id,
+          state_home: @state_home,
+          now: now
+        )
+      rescue StandardError
+        nil
+      end
+
+      def emit_automatic_clear(row, policy, aggregate, attempt, request_id, probes, now)
+        record = @events.emit_required(
+          task_folder: row.folder,
+          slug: row.slug,
+          stage: row.stage,
+          event_type: :marker_cleared,
+          message: "cleared #{policy.reason} marker for automatic retry",
+          details: base_details(row, now).merge(
+            "marker_id" => policy.marker_id,
+            "marker_reason" => policy.reason,
+            "actor" => "daemon_auto_retry",
+            "probes" => probes,
+            "health_fingerprint" => aggregate.fingerprint,
+            "attempt" => attempt,
+            "request_id" => request_id,
+            "action" => "retry_queued",
+            "rationale" => "marker cleared and same-stage run queued"
+          )
+        )
+        raise IOError, "automatic marker-clear audit was not persisted" if record.nil?
+
+        record
+      end
+
+      def dry_run_result(row, attempt, aggregate, now)
+        rationale = "health and safety gates pass; dry-run leaves state unchanged"
+        audit(row, action: "would_retry", rationale: rationale,
+                   aggregate: aggregate, attempt: attempt,
+                   transition: true, task_event: false, now: now)
+        Result.new(
+          action: "would_retry", rationale: rationale,
+          attempt: attempt, fingerprint: aggregate.fingerprint
+        )
+      end
+
+      def audit(row, action:, rationale:, now:, aggregate: nil, attempt: nil,
+                request_id: nil, transition: false, task_event: true)
+        details = base_details(row, now).merge(
+          "marker_id" => row.marker_attrs.to_h["marker_id"].to_s,
+          "marker_reason" => row.marker_attrs.to_h["reason"].to_s,
+          "actor" => "daemon_auto_retry",
+          "probes" => aggregate ? probe_summaries(aggregate) : [],
+          "health_fingerprint" => aggregate&.fingerprint,
+          "attempt" => attempt,
+          "request_id" => request_id,
+          "action" => action.to_s,
+          "rationale" => rationale.to_s
+        )
+        return if !transition && negative_audit_throttled?(details, now)
+
+        if task_event && !@dry_run && !row.folder.to_s.empty?
+          @events.emit(
+            task_folder: row.folder, slug: row.slug, stage: row.stage,
+            event_type: :auto_retry_decision,
+            message: "#{action}: #{rationale}",
+            details: details
+          )
+        end
+        @audit.call(**details.transform_keys(&:to_sym), transition: transition)
+      rescue ArgumentError, JSON::GeneratorError
+        nil
+      end
+
+      def base_details(row, now)
+        {
+          "task_id" => row.id,
+          "task_slug" => row.slug.to_s,
+          "project" => row.project.to_s,
+          "stage" => row.stage.to_s,
+          "timestamp" => now.utc.iso8601(6)
+        }
+      end
+
+      def probe_summaries(aggregate)
+        Array(aggregate.probes).map do |probe|
+          {
+            "name" => probe.name.to_s,
+            "healthy" => probe.healthy == true,
+            "exit_status" => probe.exit_status,
+            "timed_out" => probe.timed_out == true,
+            "duration_ms" => probe.duration_ms.to_i,
+            "rationale" => probe.rationale.to_s.byteslice(0, 256).to_s.scrub
+          }
+        end
+      end
+
+      def unhealthy_rationale(aggregate)
+        failed = Array(aggregate.probes).reject(&:healthy).map(&:name)
+        failed.empty? ? "dependency probe aggregate is unhealthy" :
+          "unhealthy probes: #{failed.join(', ')}"
+      end
+
+      def marker_key(row)
+        id = row.marker_attrs.to_h["marker_id"].to_s
+        return nil if id.empty?
+
+        [ row.folder.to_s, row.marker_attrs.to_h["reason"].to_s, id ]
+      end
+
+      def pending_retry_request(row, marker_id)
+        expected_argv = [
+          "hive", "run", row.slug, "--project", row.project,
+          "--stage", row.stage
+        ]
+        @request_queue.pending(state_home: @state_home).find do |request|
+          request.project.to_s == row.project.to_s &&
+            request.slug.to_s == row.slug.to_s &&
+            request.argv == expected_argv &&
+            request.requestor.to_s == "healer" &&
+            request.trigger.to_s == "recoverable_dependency_failure" &&
+            request.expected_cleared_marker_id.to_s == marker_id.to_s
+        end
+      rescue SystemCallError, IOError
+        nil
+      end
+
+      def probe(row, policy, reason, now)
+        task_key = probe_task_key(row)
+        tick_key = [ row.project.to_s, reason.to_s ]
+        return @tick_probe_cache.fetch(tick_key) if @tick_probe_cache.key?(tick_key)
+
+        runner = @probe_factory.call(row, policy)
+        cheap = runner.cheap_fingerprint(reason: reason)
+        context_key = [ task_key, reason.to_s ]
+        cached = @probe_cache[context_key]
+        aggregate = if cached && cached[:cheap] == cheap &&
+                       (now - cached[:checked_at]) < PROBE_FALLBACK_SEC
+          cached[:aggregate]
+        else
+          fresh = runner.call(reason: reason)
+          @probe_cache[context_key] = {
+            cheap: cheap, checked_at: now, aggregate: fresh
+          }
+          fresh
+        end
+        @tick_probe_cache[tick_key] = aggregate
+      end
+
+      def probe_task_key(row)
+        [
+          row.project.to_s,
+          row.id.to_s,
+          row.slug.to_s,
+          row.folder.to_s
+        ]
+      end
+
+      def evict_negative_audits(now)
+        @negative_audits.delete_if do |_key, recorded_at|
+          (now - recorded_at) >= NEGATIVE_AUDIT_THROTTLE_SEC
+        end
+      end
+
+      def negative_audit_throttled?(details, now)
+        key = [
+          details["task_slug"], details["stage"], details["marker_id"],
+          details["marker_reason"], details["health_fingerprint"],
+          details["action"], details["rationale"]
+        ]
+        previous = @negative_audits[key]
+        return true if previous && (now - previous) < NEGATIVE_AUDIT_THROTTLE_SEC
+
+        @negative_audits[key] = now
+        false
+      end
+    end
+  end
+end
